<p>Définition de l'opérateur switchMap:
    Map vers une Observable, complète l'Observable interne précédente, emet des valeurs.
</p>

<p>Comment fonctionne un switchMap ?
    En se rendant dans le "switch-map service", on peut voir qu'on réalise un appel GET
    au serveur Spring Boot qui retourne une liste de produits. Appliquer l'opérateur switchMap
    sur la liste de produits retournée par le serveur a pour effet d'émetter, pour chaque produit
    de la liste, une observable.
    En d'autres termes, l'opérateur switchMap va transformer la méthode GET, qui retourne une seule
    Observable, en un flux d'Observable et chaque Observable représente un produit de la liste.
    C'est pour cette raison qu'en appliquant l'opérateur tap et en loggant les données, on obtient
    un logging dans la console par produit de la liste.
    Ainsi, grâce à l'opérateur map qui suit l'opérateur tap, il devient aisé de transformer chaque
    produit de la liste un par un en tant que flux.
    Enfin, l'opérateur toArray retourne un tableau. L'opérateur attend que les Observables soient
    toutes émises avant de retourner le tableau (que la source soit à l'état "complete"). Sans cet opérateur toArray, notre composant qui
    s'abonne à notre service ne recevrait pas un tableau mais un unique produit (il recevrait le dernier
    produit dû à l'opérateur switchMap qui émettra le dernier produit.)
</p>

<ng-container *ngIf="products$ | async as products">
    <ng-container *ngFor="let product of products">
        <div>{{ product.name }}</div>
    </ng-container>
</ng-container>
